SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TestTusLibros
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:52'!
aNewCart

	^ Cart newCart.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:50'!
aNewCartForAClient

	^ Cart createCartForClient: (self luisClientID) withPassword: (self luisPassword)! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/27/2013 21:07'!
luisClientID

	^ 123456.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/27/2013 21:07'!
luisPassword

	^ 'luis2013'.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:48'!
someBook

	^ 123456.! !

!TestTusLibros methodsFor: 'something' stamp: 'PabloRago 5/29/2013 19:48'!
someOtherBook

	^ 987654.! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/27/2013 21:54'!
test01CreatedCartShouldBeEmpty
	
	
	self assert: (self aNewCart) isEmpty.! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:39'!
test02BooksAddedToTheCartShouldBeInTheCart
	
	self assert: (((self aNewCart) add: self someBook) includes: self someBook).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:39'!
test03TheCartShouldOnlyContainTheAddedBooks
	
	| aCart |
	
	aCart := self aNewCart.
	aCart add: self someBook. 
	aCart add: self someOtherBook.

	self assert: (aCart includes: self someBook).
	self assert: (aCart includes: self someOtherBook).
	self assert: (aCart size = 2).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:39'!
test04TheCartCanContainTwoCopiesOfTheSameBook
	
	| aCart |
	
	aCart := self aNewCart.
	aCart add: self someBook. 
	aCart add: self someBook.

	self assert: (aCart includes: self someBook).
	self assert: (aCart size = 2).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:43'!
test05TheCartCanContainManyCopiesOfManySameBook
	
	| aCart |
	
	aCart := self aNewCart.
	
	aCart add: self someBook. 
	aCart add: self someBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	
	self assert: ((aCart occurrencesOf: self someBook) = 2).
	self assert: ((aCart occurrencesOf: self someOtherBook) = 3).! !

!TestTusLibros methodsFor: '1 Tests Cart' stamp: 'PabloRago 5/29/2013 19:40'!
test06CartCanListAddedBooks
	
	| aCart amountSomeOtherBook amountSomeBook|
	
	aCart := self aNewCart.
	
	aCart add: self someBook. 
	aCart add: self someBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	aCart add: self someOtherBook.
	
	amountSomeOtherBook := 0.
	amountSomeBook := 0.
	
	aCart listAddedBooks do: [ :aBook | 
	(aBook = self someOtherBook)
		ifTrue: [ amountSomeOtherBook := amountSomeOtherBook + 1 ]  .
	(aBook = self someBook)
		ifTrue: [ amountSomeBook := amountSomeBook + 1 ].
	].

	self assert: amountSomeOtherBook = 3.
	self assert: amountSomeBook = 2.! !

Object subclass: #Cart
	instanceVariableNames: 'bag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:53'!
newCart

	| aCart |
	
	aCart := Cart new.
	aCart bag: Bag new.
	
	^ aCart.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:55'!
add: anElement 

	bag add: anElement .! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:55'!
bag: aBag 

	bag := aBag.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:55'!
includes: anElement 

	^bag includes:  anElement .! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:55'!
isEmpty

	^ bag isEmpty.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:55'!
occurrencesOf: anElement 

	^bag occurrencesOf:  anElement .! !

!Cart methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/29/2013 19:56'!
size 

	^ bag size.! !
